/*
-- ========================================================================== --
-- RECSUBSEMA
-- ========================================================================== --
*/
CREATE OR REPLACE VIEW RECSUBSEMA(CDFILIAL,CDCIA,CDMANCIA,CDSERVICO,CDCLASSE,
                                  CDCICLO,CDSUBGRU,CDRECEITA,QTRECSUMA,
                                  SGUNIDADE,TXCOMRECSUMA,VRLOADRSUMA,
                                  NRORDRSUMA,IDIMPRECDEL,
                                  /* campos novos */
                                  CDESPEPROD,CDTIPOCOMP,CDARVREC,DSRECEITA,
                                  DSSUBGRU,DSSERVICO,DSEXTSE,DSRECIN,
                                  DSRECES)
AS
SELECT ES.CDFILIAL,P3.CDCIA,ES.CDMANCIA,ES.CDPRODUTO,P3.CDCLASSE,
       P3.CDCICLO,CP.CDPRODUTO,CP.CDPRODINSUMO,CP.QTINSUMO,
       P2.SGUNIDADE,CP.TXCOMITCOMP,CP.VRLOADCOMP,
       CP.NRORDCOMP,CP.IDIMPCOMPDEL,
       /* campos novos */
       CP.CDESPEPROD,CP.CDTIPOCOMP,P2.CDARVPROD,P2.NMPRODUTO,
       P1.NMPRODUTO,P3.NMPRODUTO,P3.DSEXTSERV,P2.NMPRODINGLES,
       P2.NMPRODESPANH
FROM COMPPROD CP, ESPEPROD EP, TCOMPPRO TC, PRODUTO P1, PRODUTO P2,
     COMPPROD CO, ESPEPROD ES, PRODUTO P3
WHERE (EP.CDPRODUTO    = CP.CDPRODUTO   ) AND
      (EP.CDESPEPROD   = CP.CDESPEPROD  ) AND
      (EP.IDTPMANUAL   = 'M'            ) AND
      --(EP.IDCOMPPADRAO = 'P'            ) AND
      (TC.CDPRODUTO    = CP.CDPRODUTO   ) AND
      (TC.CDESPEPROD   = CP.CDESPEPROD  ) AND
      (TC.CDTIPOCOMP   = CP.CDTIPOCOMP  ) AND
      (TC.IDTCOMPPROC  = 'S'            ) AND
      (P1.CDPRODUTO    = CP.CDPRODUTO   ) AND
      (P1.IDPRODCOMISS = '2'            ) AND
      (P2.CDPRODUTO    = CP.CDPRODINSUMO) AND
      (P2.IDPRODCOMISS = '3'            ) AND
      (CO.CDPRODINSUMO = CP.CDPRODUTO   ) AND
      (CO.CDESPEPROD   = CP.CDESPPRODAUX) AND
      (CO.CDPRODUTO    = CP.CDPRODUTOAUX) AND
      (P3.CDPRODUTO    = CO.CDPRODUTO   ) AND
      (P3.IDPRODCOMISS = '1'            ) AND
      (ES.CDPRODUTO    = CO.CDPRODUTO   ) AND
      (ES.CDESPEPROD   = CO.CDESPEPROD  ) AND
      (ES.IDTPMANUAL   = 'M'            )
/
